From 615d3cf3f9c4319f99193e84d3fd19a3e85c3fd0 Mon Sep 17 00:00:00 2001
From: Wen Gong <wgong@codeaurora.org>
Date: Mon, 8 Jun 2020 16:23:38 +0800
Subject: [PATCH 31/69] ath11k: add regdb.bin download for regdb offload

The regdomain is self-managed type for ath11k, it is reported from
firmware. Firmware fetch the regdomain info from board data file, but
the board data file is not maintained by customer, regdb.bin will be
maintained by customer and then it can be updated by customer to meet
request of them. After download regdb.bin, firmware will fetch the
regdomain info from regdb.bin instead of board data file and report
to ath11k. If it does not have regdb.bin, it also can initialize wlan
success and firmware then fetch regdomain info from board data file.

regdomain info report from firmware, it include alpha2 code, dfs_region,
flags, max bandwidth, frequency ranges and max transmit power.
dmesg:
               Country US, CFG Regdomain FCC FW Regdomain 1, num_reg_rules 6
[72924.106318] ath11k_pci 0000:05:00.0:         1. (2402 - 2472 @ 40) (6, 30) (0 ms) (FLAGS 0)
[72924.106323] ath11k_pci 0000:05:00.0:         2. (5170 - 5250 @ 80) (0, 24) (0 ms) (FLAGS 2048)
[72924.106329] ath11k_pci 0000:05:00.0:         3. (5250 - 5330 @ 80) (0, 24) (0 ms) (FLAGS 2064)
[72924.106333] ath11k_pci 0000:05:00.0:         4. (5490 - 5730 @ 160) (0, 24) (0 ms) (FLAGS 2064)
[72924.106337] ath11k_pci 0000:05:00.0:         5. (5735 - 5895 @ 160) (0, 30) (0 ms) (FLAGS 2048)
[72924.106341] ath11k_pci 0000:05:00.0:         6. (5945 - 7125 @ 160) (0, 24) (0 ms) (FLAGS 2056)

download regdb.bin log:
[74625.073294] ath11k_pci 0000:05:00.0: qmi firmware memory ready indication
[74625.077257] ath11k_pci 0000:05:00.0: chip_id 0x0 chip_family 0xb board_id 0x101 soc_id 0x400c0100
[74625.077286] ath11k_pci 0000:05:00.0: fw_version 0x110f0500 fw_build_timestamp 2020-10-30 16:52 fw_build_id

[74625.077365] ath11k_pci 0000:05:00.0: boot firmware request ath11k/QCA6490/hw1.1/regdb.bin size 19348

[74625.083654] ath11k_pci 0000:05:00.0: boot using board name 'bus=pci,qmi-chip-id=0,qmi-board-id=257'
[74625.083744] ath11k_pci 0000:05:00.0: boot firmware request ath11k/QCA6490/hw1.1/board.bin size 59872
[74625.083747] ath11k_pci 0000:05:00.0: using board api 1
[74625.100038] ath11k_pci 0000:05:00.0: boot firmware request ath11k/QCA6490/hw1.1/m3.bin size 266684
[74625.100174] ath11k_pci 0000:05:00.0: m3 paddr:0x30680000
[74625.100176] ath11k_pci 0000:05:00.0: M3 data

iw reg get
global
country US: DFS-FCC
        (2402 - 2472 @ 40), (N/A, 30), (N/A)
        (5170 - 5250 @ 80), (N/A, 23), (N/A), AUTO-BW
        (5250 - 5330 @ 80), (N/A, 23), (0 ms), DFS, AUTO-BW
        (5490 - 5730 @ 160), (N/A, 23), (0 ms), DFS
        (5735 - 5835 @ 80), (N/A, 30), (N/A)
        (57240 - 63720 @ 2160), (N/A, 40), (N/A)

phy#0 (self-managed)
country US: DFS-FCC
        (2402 - 2472 @ 40), (6, 30), (N/A)
        (5170 - 5250 @ 80), (N/A, 24), (N/A), AUTO-BW
        (5250 - 5330 @ 80), (N/A, 24), (0 ms), DFS, AUTO-BW
        (5490 - 5730 @ 160), (N/A, 24), (0 ms), DFS, AUTO-BW
        (5735 - 5895 @ 160), (N/A, 30), (N/A), AUTO-BW
        (5945 - 7125 @ 160), (N/A, 24), (N/A), NO-OUTDOOR, AUTO-BW

Tested-on: QCA6390 hw2.0 PCI WLAN.HST.1.0.1-01230-QCAHSTSWPLZ_V2_TO_X86-1
Tested-on: QCA6490 hw1.1 PCI WLAN.HSP.1.1-01121-QCAHSPSWPL_V1_V2_SILICONZ_LITE-1

Signed-off-by: Wen Gong <wgong@codeaurora.org>
---
 drivers/net/wireless/ath/ath11k/core.c | 10 +++++----
 drivers/net/wireless/ath/ath11k/core.h |  3 +++
 drivers/net/wireless/ath/ath11k/hw.h   |  1 +
 drivers/net/wireless/ath/ath11k/qmi.c  | 28 +++++++++++++++++++-------
 drivers/net/wireless/ath/ath11k/qmi.h  |  1 +
 5 files changed, 32 insertions(+), 11 deletions(-)

diff --git a/drivers/net/wireless/ath/ath11k/core.c b/drivers/net/wireless/ath/ath11k/core.c
index 0e412a02ef81..054c00aac73a 100644
--- a/drivers/net/wireless/ath/ath11k/core.c
+++ b/drivers/net/wireless/ath/ath11k/core.c
@@ -596,10 +596,12 @@ static int ath11k_core_fetch_board_data_api_n(struct ath11k_base *ab,
 	return ret;
 }
 
-static int ath11k_core_fetch_board_data_api_1(struct ath11k_base *ab,
-					      struct ath11k_board_data *bd)
+int ath11k_core_fetch_board_data_api_1(struct ath11k_base *ab,
+				       struct ath11k_board_data *bd,
+				       char *name)
 {
-	bd->fw = ath11k_core_firmware_request(ab, ATH11K_DEFAULT_BOARD_FILE);
+	bd->fw = ath11k_core_firmware_request(ab, name);
+
 	if (IS_ERR(bd->fw))
 		return PTR_ERR(bd->fw);
 
@@ -627,7 +629,7 @@ int ath11k_core_fetch_bdf(struct ath11k_base *ab, struct ath11k_board_data *bd)
 		goto success;
 
 	ab->bd_api = 1;
-	ret = ath11k_core_fetch_board_data_api_1(ab, bd);
+	ret = ath11k_core_fetch_board_data_api_1(ab, bd, ATH11K_DEFAULT_BOARD_FILE);
 	if (ret) {
 		ath11k_err(ab, "failed to fetch board-2.bin or board.bin from %s\n",
 			   ab->hw_params.fw.dir);
diff --git a/drivers/net/wireless/ath/ath11k/core.h b/drivers/net/wireless/ath/ath11k/core.h
index 9df281363c43..89a3fee297f2 100644
--- a/drivers/net/wireless/ath/ath11k/core.h
+++ b/drivers/net/wireless/ath/ath11k/core.h
@@ -949,6 +949,9 @@ struct ath11k_base *ath11k_core_alloc(struct device *dev, size_t priv_size,
 void ath11k_core_free(struct ath11k_base *ath11k);
 int ath11k_core_fetch_bdf(struct ath11k_base *ath11k,
 			  struct ath11k_board_data *bd);
+int ath11k_core_fetch_board_data_api_1(struct ath11k_base *ab,
+				       struct ath11k_board_data *bd,
+				       char *name);
 void ath11k_core_free_bdf(struct ath11k_base *ab, struct ath11k_board_data *bd);
 int ath11k_core_check_dt(struct ath11k_base *ath11k);
 
diff --git a/drivers/net/wireless/ath/ath11k/hw.h b/drivers/net/wireless/ath/ath11k/hw.h
index 7d91e49bdac2..72c37cc0ca49 100644
--- a/drivers/net/wireless/ath/ath11k/hw.h
+++ b/drivers/net/wireless/ath/ath11k/hw.h
@@ -76,6 +76,7 @@
 #define ATH11K_DEFAULT_CAL_FILE		"caldata.bin"
 #define ATH11K_AMSS_FILE		"amss.bin"
 #define ATH11K_M3_FILE			"m3.bin"
+#define ATH11K_REGDB_FILE_NAME		"regdb.bin"
 
 enum ath11k_hw_rate_cck {
 	ATH11K_HW_RATE_CCK_LP_11M = 0,
diff --git a/drivers/net/wireless/ath/ath11k/qmi.c b/drivers/net/wireless/ath/ath11k/qmi.c
index 3471cdc5c1bb..0af9396e7a7c 100644
--- a/drivers/net/wireless/ath/ath11k/qmi.c
+++ b/drivers/net/wireless/ath/ath11k/qmi.c
@@ -2023,7 +2023,8 @@ static int ath11k_qmi_load_bdf_fixed_addr(struct ath11k_base *ab)
 	return ret;
 }
 
-static int ath11k_qmi_load_bdf_qmi(struct ath11k_base *ab)
+static int ath11k_qmi_load_bdf_qmi(struct ath11k_base *ab,
+				   bool regdb)
 {
 	struct qmi_wlanfw_bdf_download_req_msg_v01 *req;
 	struct qmi_wlanfw_bdf_download_resp_msg_v01 resp;
@@ -2038,9 +2039,17 @@ static int ath11k_qmi_load_bdf_qmi(struct ath11k_base *ab)
 	if (!req)
 		return -ENOMEM;
 	memset(&resp, 0, sizeof(resp));
-
 	memset(&bd, 0, sizeof(bd));
-	ret = ath11k_core_fetch_bdf(ab, &bd);
+
+	if (regdb) {
+		ret = ath11k_core_fetch_board_data_api_1(ab, &bd, ATH11K_REGDB_FILE_NAME);
+		if (ret)
+			ath11k_dbg(ab, ATH11K_DBG_QMI, "failed to fetch %s from %s\n",
+				   ATH11K_REGDB_FILE_NAME, ab->hw_params.fw.dir);
+	} else {
+		ret = ath11k_core_fetch_bdf(ab, &bd);
+	}
+
 	if (ret) {
 		ath11k_warn(ab, "qmi failed to load bdf:\n");
 		goto out;
@@ -2049,7 +2058,9 @@ static int ath11k_qmi_load_bdf_qmi(struct ath11k_base *ab)
 	temp = bd.data;
 	remaining = bd.len;
 
-	if (bd.len >= SELFMAG && memcmp(bd.data, ELFMAG, SELFMAG) == 0)
+	if (regdb)
+		bdf_type = ATH11K_QMI_BDF_TYPE_REGDB;
+	else if (bd.len >= SELFMAG && memcmp(bd.data, ELFMAG, SELFMAG) == 0)
 		bdf_type = ATH11K_QMI_BDF_TYPE_ELF;
 	else
 		bdf_type = ATH11K_QMI_BDF_TYPE_BIN;
@@ -2490,10 +2501,13 @@ static int ath11k_qmi_event_load_bdf(struct ath11k_qmi *qmi)
 		return ret;
 	}
 
-	if (ab->bus_params.fixed_bdf_addr)
+	if (ab->bus_params.fixed_bdf_addr) {
 		ret = ath11k_qmi_load_bdf_fixed_addr(ab);
-	else
-		ret = ath11k_qmi_load_bdf_qmi(ab);
+	} else {
+		ath11k_qmi_load_bdf_qmi(ab, true);
+		ret = ath11k_qmi_load_bdf_qmi(ab, false);
+	}
+
 	if (ret < 0) {
 		ath11k_warn(ab, "qmi failed to load board data file:%d\n", ret);
 		return ret;
diff --git a/drivers/net/wireless/ath/ath11k/qmi.h b/drivers/net/wireless/ath/ath11k/qmi.h
index ffdcfd50c88a..5d4f4bd2db39 100644
--- a/drivers/net/wireless/ath/ath11k/qmi.h
+++ b/drivers/net/wireless/ath/ath11k/qmi.h
@@ -50,6 +50,7 @@ enum ath11k_qmi_file_type {
 enum ath11k_qmi_bdf_type {
 	ATH11K_QMI_BDF_TYPE_BIN			= 0,
 	ATH11K_QMI_BDF_TYPE_ELF			= 1,
+	ATH11K_QMI_BDF_TYPE_REGDB		= 4,
 };
 
 enum ath11k_qmi_event_type {
-- 
2.25.1

